/*******************************************************************************
 * FoxGameObject_WeaponDepot generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameObject_WeaponDepot extends FoxStation_Base
    native
    config(Game)
    notplaceable
    hidecategories(Navigation);

var() array<MaterialInterface> DepotMaterialOverrides;
var array<MaterialInstanceConstant> WeaponDepotMICs;
var() const name DepotOnOffMaterialParameterName;
var() const name DepotDialOnOffMaterialParameterName;
var() const name DepotMonitorColorParameterName;
var private transient LinearColor CachedDepotMonitorColorParameterValue;
var private export editinline ParticleSystemComponent UsedParticleSystemComponent;
var protected array<FoxPawn> UsingPawns;
var repnotify name CurrentStateName;
var bool bLocallyActiveUsing;
var private bool bForceDisabled;
var const array<string> DepotItemNames;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        CurrentStateName
}

simulated function ReplicatedEvent(name VarName)
{
    // End:0x28
    if(VarName == 'CurrentStateName')
    {
        GotoState(CurrentStateName);
    }
    // End:0x3B
    else
    {
        super(FoxGameObject_Use).ReplicatedEvent(VarName);
    }
    //return;    
}

simulated function PostBeginPlay()
{
    local int I;
    local MaterialInstanceConstant NewMIC;
    local FoxPC LocalPC;

    super(FoxGameObject_Use).PostBeginPlay();
    // End:0xDF
    if(DepotMaterialOverrides.Length > 0)
    {
        I = 0;
        J0x25:
        // End:0xDC [Loop If]
        if(I < DepotMaterialOverrides.Length)
        {
            NewMIC = new (self) class'MaterialInstanceConstant';
            NewMIC.SetParent(DepotMaterialOverrides[I]);
            ObjectMesh.SetMaterial(I, NewMIC);
            WeaponDepotMICs.AddItem(NewMIC);
            ++ I;
            // [Loop Continue]
            goto J0x25;
        }
    }
    // End:0x16D
    else
    {
        I = 0;
        J0xEA:
        // End:0x16D [Loop If]
        if(I < ObjectMesh.GetNumElements())
        {
            NewMIC = ObjectMesh.CreateAndSetMaterialInstanceConstant(I);
            WeaponDepotMICs.AddItem(NewMIC);
            ++ I;
            // [Loop Continue]
            goto J0xEA;
        }
    }
    I = 0;
    J0x178:
    // End:0x1D9 [Loop If]
    if(I < WeaponDepotMICs.Length)
    {
        WeaponDepotMICs[I].GetVectorParameterValue(DepotMonitorColorParameterName, CachedDepotMonitorColorParameterValue);
        ++ I;
        // [Loop Continue]
        goto J0x178;
    }
    // End:0x252
    foreach LocalPlayerControllers(class'FoxPC', LocalPC)
    {
        // End:0x251
        if(LocalPC.MyFoxHud != none)
        {
            LocalPC.MyFoxHud.AddPostRenderedActor(self);
        }        
    }    
    TurnDepotMonitorOff();
    SetTimer(1.0, false, 'UpdateEnabledStatus');
    //return;    
}

simulated function UpdateEnabledStatus()
{
    local bool bNewEnabled;

    // End:0x85
    if(WorldInfo.GRI != none)
    {
        bNewEnabled = !FoxGRI(WorldInfo.GRI).IsMutatorEnabled(3);
        ToggleDepot(bNewEnabled, false);
    }
    //return;    
}

event ToggleDepot(bool bEnable, optional bool bForced)
{
    bForced = true;
    // End:0x98
    if(!bForceDisabled || bForced)
    {
        bForceDisabled = !bEnable && bForced;
        // End:0x69
        if(!bEnable)
        {
            GotoState('DepotDisabled');
        }
        // End:0x98
        else
        {
            // End:0x8A
            if(PawnsInVolume.Length > 0)
            {
                GotoState('DepotActive');
            }
            // End:0x98
            else
            {
                GotoState('DepotInactive');
            }
        }
    }
    //return;    
}

simulated function TurnDepotMonitorOn()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x6C [Loop If]
    if(I < WeaponDepotMICs.Length)
    {
        WeaponDepotMICs[I].SetVectorParameterValue(DepotMonitorColorParameterName, CachedDepotMonitorColorParameterValue);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

simulated function TurnDepotMonitorOff()
{
    local LinearColor DefaultLinearColor;
    local int I;

    I = 0;
    J0x0B:
    // End:0x6C [Loop If]
    if(I < WeaponDepotMICs.Length)
    {
        WeaponDepotMICs[I].SetVectorParameterValue(DepotMonitorColorParameterName, DefaultLinearColor);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

simulated function TurnDepotOn()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x9F [Loop If]
    if(I < WeaponDepotMICs.Length)
    {
        WeaponDepotMICs[I].SetScalarParameterValue(DepotOnOffMaterialParameterName, 1.0);
        WeaponDepotMICs[I].SetScalarParameterValue(DepotDialOnOffMaterialParameterName, 1.0);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

simulated function TurnDepotOff()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x9F [Loop If]
    if(I < WeaponDepotMICs.Length)
    {
        WeaponDepotMICs[I].SetScalarParameterValue(DepotOnOffMaterialParameterName, 0.0);
        WeaponDepotMICs[I].SetScalarParameterValue(DepotDialOnOffMaterialParameterName, 0.0);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function Ping()
{
    //return;    
}

simulated function ActivateDepotLocally()
{
    bLocallyActiveUsing = true;
    //return;    
}

simulated function DeActivateDepotLocally()
{
    bLocallyActiveUsing = false;
    //return;    
}

function StartUsingServer(FoxPawn UsingPawn)
{
    FoxGame(WorldInfo.Game).BroadcastPawnUseDialog(6, UsingPawn, byte(UsingPawn.PlayerReplicationInfo.Team.TeamIndex));
    AddPawnToUsingList(UsingPawn);
    super(FoxGameObject_Use).StartUsingServer(UsingPawn);
    //return;    
}

simulated function StartUsingLocal(FoxPawn UsingPawn)
{
    ActivateDepotLocally();
    super(FoxGameObject_Use).StartUsingLocal(UsingPawn);
    //return;    
}

protected function StopUsingServer(FoxPawn UsingPawn)
{
    RemovePawnFromUsingList(UsingPawn);
    super(FoxGameObject_Use).StopUsingServer(UsingPawn);
    //return;    
}

simulated function StopUsingLocal(FoxPawn UsingPawn)
{
    DeActivateDepotLocally();
    super(FoxGameObject_Use).StopUsingLocal(UsingPawn);
    //return;    
}

simulated function PawnLeavingUseVolume(Pawn LeavingPawn)
{
    super.PawnLeavingUseVolume(LeavingPawn);
    //return;    
}

function AddPawnToUsingList(FoxPawn Pawn)
{
    local bool bWasDepotActive, bDepotActive;

    bWasDepotActive = UsingPawns.Length > 0;
    // End:0x4A
    if(UsingPawns.Find(Pawn) < 0)
    {
        UsingPawns.AddItem(Pawn);
    }
    bDepotActive = UsingPawns.Length > 0;
    // End:0x8E
    if(!bWasDepotActive && bDepotActive)
    {
        GotoState('DepotInUse');
    }
    //return;    
}

function RemovePawnFromUsingList(FoxPawn Pawn)
{
    local bool bWasDepotActive, bDepotActive;

    bWasDepotActive = UsingPawns.Length > 0;
    UsingPawns.RemoveItem(Pawn);
    bDepotActive = UsingPawns.Length > 0;
    // End:0x72
    if(bWasDepotActive && !bDepotActive)
    {
        GotoState('DepotActive');
    }
    //return;    
}

// Export UFoxGameObject_WeaponDepot::execCanInteractWith(FFrame&, void* const)
native simulated function bool CanInteractWith(FoxPawn InteractingPawn);

// Export UFoxGameObject_WeaponDepot::execIsPawnUsingObject(FFrame&, void* const)
native simulated function bool IsPawnUsingObject(const FoxPawn Pawn);

// Export UFoxGameObject_WeaponDepot::execIsLocalPawn(FFrame&, void* const)
native simulated function bool IsLocalPawn(const Pawn P);

simulated function ToggleHRVEffects(const bool bHRVEnabled)
{
    local int I;

    // End:0xB7
    if((IsDepotAllowed()) && bHRVEnabled)
    {
        I = 0;
        J0x27:
        // End:0x93 [Loop If]
        if(I < ObjectMesh.GetNumElements())
        {
            ObjectMesh.SetMaterial(I, HRVMaterial);
            ++ I;
            // [Loop Continue]
            goto J0x27;
        }
        ObjectMesh.SetDepthPriorityGroup(2);
    }
    // End:0x19D
    else
    {
        I = 0;
        J0xC2:
        // End:0x17C [Loop If]
        if(I < ObjectMesh.GetNumElements())
        {
            // End:0x145
            if(I < WeaponDepotMICs.Length)
            {
                ObjectMesh.SetMaterial(I, WeaponDepotMICs[I]);
            }
            // End:0x16E
            else
            {
                ObjectMesh.SetMaterial(I, none);
            }
            ++ I;
            // [Loop Continue]
            goto J0xC2;
        }
        ObjectMesh.SetDepthPriorityGroup(1);
    }
    //return;    
}

simulated event bool IsDepotAllowed()
{
    return bEnabled;
    //return ReturnValue;    
}

simulated state DepotDisabled
{
    ignores AddPawnToUsingList;

    simulated event BeginState(name PreviousStateName)
    {
        // End:0x21
        if(Role == ROLE_Authority)
        {
            CurrentStateName = GetStateName();
        }
        TurnDepotOff();
        bEnabled = false;
        //return;        
    }

    simulated event EndState(name NextStateName)
    {
        bEnabled = true;
        TurnDepotOn();
        TurnDepotMonitorOff();
        //return;        
    }

    function RemovePawnFromUsingList(FoxPawn Pawn)
    {
        UsingPawns.RemoveItem(Pawn);
        //return;        
    }
    stop;    
}

auto simulated state DepotInactive
{
    simulated event BeginState(name PreviousStateName)
    {
        // End:0x21
        if(Role == ROLE_Authority)
        {
            CurrentStateName = GetStateName();
        }
        //return;        
    }

    simulated function PawnEnteredUseVolume(Pawn EnteringPawn)
    {
        global.PawnEnteredUseVolume(EnteringPawn);
        // End:0x2E
        if(IsDepotAllowed())
        {
            GotoState('DepotActive');
        }
        //return;        
    }
    stop;    
}

simulated state DepotActive
{
    simulated event BeginState(name PreviousStateName)
    {
        // End:0x21
        if(Role == ROLE_Authority)
        {
            CurrentStateName = GetStateName();
        }
        //return;        
    }

    simulated function PawnLeavingUseVolume(Pawn LeavingPawn)
    {
        global.PawnLeavingUseVolume(LeavingPawn);
        // End:0x31
        if(PawnsInVolume.Length == 0)
        {
            GotoState('DepotInactive');
        }
        //return;        
    }
    stop;    
}

simulated state DepotInUse
{
    simulated event BeginState(name PreviousStateName)
    {
        // End:0x21
        if(Role == ROLE_Authority)
        {
            CurrentStateName = GetStateName();
        }
        TurnDepotMonitorOn();
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        TurnDepotMonitorOff();
        //return;        
    }

    function RemovePawnFromUsingList(FoxPawn Pawn)
    {
        global.RemovePawnFromUsingList(Pawn);
        OnSuccessfulUse(Pawn);
        // End:0x65
        if(UsingPawns.Length == 0)
        {
            // End:0x57
            if(PawnsInVolume.Length > 0)
            {
                GotoState('DepotActive');
            }
            // End:0x65
            else
            {
                GotoState('DepotInactive');
            }
        }
        //return;        
    }

    simulated function PawnLeavingUseVolume(Pawn LeavingPawn)
    {
        global.PawnLeavingUseVolume(LeavingPawn);
        // End:0x31
        if(PawnsInVolume.Length == 0)
        {
            GotoState('DepotInactive');
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    DepotOnOffMaterialParameterName=Blink
    DepotDialOnOffMaterialParameterName=ON_OFF
    DepotMonitorColorParameterName=Monitor_Color
    CachedDepotMonitorColorParameterValue=(R=0.0,G=0.0,B=0.0,A=1.0)
    begin object name=NewPSC class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_WeaponDepot.NewPSC'
    UsedParticleSystemComponent=NewPSC
    bDrawUseText=true
    bAllowMultipleUsers=true
    MiniGames(0)=class'FoxMiniGame_WeaponDepot'
    LocStringUse="USE DEPOT"
    LocStringSpecUse="USING DEPOT"
    begin object name=NewDepotMesh class=SkeletalMeshComponent
        bUpdateSkelWhenNotRendered=false
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_WeaponDepot.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_GameplayPhysics
        CollideActors=true
        BlockActors=true
        BlockZeroExtent=true
        BlockNonZeroExtent=true
        BlockRigidBody=true
        RBCollideWithChannels=(Default=true,GameplayPhysics=true,EffectPhysics=true,BlockingVolume=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_WeaponDepot.NewDepotMesh'
    ObjectMesh=NewDepotMesh
    Components(0)=none
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxGameObject_WeaponDepot.MyLightEnvironment'
    begin object name=NewDepotMesh class=SkeletalMeshComponent
        bUpdateSkelWhenNotRendered=false
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_WeaponDepot.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_GameplayPhysics
        CollideActors=true
        BlockActors=true
        BlockZeroExtent=true
        BlockNonZeroExtent=true
        BlockRigidBody=true
        RBCollideWithChannels=(Default=true,GameplayPhysics=true,EffectPhysics=true,BlockingVolume=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_WeaponDepot.NewDepotMesh'
    Components(2)=NewDepotMesh
    begin object name=NewPSC class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_WeaponDepot.NewPSC'
    Components(3)=NewPSC
    bNoDelete=true
    bUpdateSimulatedPosition=false
    bCollideActors=true
    bCollideWorld=true
    bBlockActors=true
    bProjTarget=true
    bNoEncroachCheck=true
    bEdShouldSnap=true
}